//xsetaseta@gmail.com
//23/11/2015
//___Arduino_1.0.5___________-
//Debian 7

#include <SoftwareSerial.h>

#define numeroDisplay  9


char entradaBT[100]; 
int contadorBT=0;
char inCharBT;

// MAX7219
const static byte segmentos[60]={0,255,255,255,255,255,255,255,255,255,255,255,255,1,128,128,   //space-/                            
                            B01111110,B00110000,B01101101,B01111001,B00110011,B01011011,B01011111,B01110000, B01111111,B01111011,//0-9
                            B01110111,B00011111,B00001101,B00111101,B01001111,B01000111,B00000000,// : - @
                            119,31,78,61,79,71,94,23,16,60,7,14,118,21,29,103,115,5,91,70,62,28,63,55,59,73}; // A-Z
                            
unsigned char midisplay[numeroDisplay];
int LEDCONTROL_SPI_MOSI;
int LEDCONTROL_SPI_CLK;
int LEDCONTROL_SPI_CS;


//char VARI[10];
char VARI_scroll[80];
char scroll=0;

String inputString = "";  

//mode 0  ->scroll_ON
//mode 1  ->scroll_OFF
char mode=0;

unsigned int tiempo,tiempo1;

SoftwareSerial BT(A0,A1); // RX | TX

void setup() 
{            
  Serial.begin(9600); 
  BT.begin(9600);
  LedControl(12,11,10);     
  setIntensity(0);
  DisplayS("abcdefgh");
  delay(600);
  DisplayN(12345678);
  delay(600);
  DisplayS("hola");
}

void loop()
{
  delay(1);
  InBluetooth();
   
  if(tiempo1>500)
    {
     tiempo1=0;
     if(mode==1) DisplayScroll();                                                                                                                                                                                                                                                     
    }
  tiempo1++;  

}


void InBluetooth()
{
  int z;
  
  while (BT.available())
   {
    inCharBT = (char)BT.read(); 
    entradaBT[contadorBT]=inCharBT;
    contadorBT++;  
    if (inCharBT == '\n')
        {
          entradaBT[contadorBT]=0;
          Serial.println(entradaBT);
          for(z=0;z<=contadorBT;z++)
            {
              if(entradaBT[z]>='a'&& entradaBT[z]<='z') entradaBT[z]=entradaBT[z]-32; //Minusculas a mayusculas
            }
          memcpy(VARI_scroll,entradaBT,79);
          
          contadorBT=0;          
          
          if(VARI_scroll[0]=='/')
           {
             mode=1;
             VARI_scroll[0]=32;
             scroll=1;
             DisplayScroll();
           }
           else
           {
             mode=0;
             scroll=0;
             DisplayS(VARI_scroll);
           }          
        }   
   } 
}

void serialEvent() 
{
 char inChar;
  while (Serial.available()) 
   {
    inChar= (char)Serial.read(); 
    inputString += inChar;
    BT.write(inChar);
    if (inChar == '\n')   //Arduino terminal
    //if (inChar == 13)       //Proteus
       { 
         inputString.toCharArray(VARI_scroll,79);
         if(VARI_scroll[0]=='/')
           {
             mode=1;
             VARI_scroll[0]=32;
             scroll=1;
             DisplayScroll();
           }
           else
           {
             mode=0;
             scroll=0;
             DisplayS(VARI_scroll);
           }
         inputString="";
                   
       }
   }
}

void DisplayScroll()
{
int z;
unsigned char c;
 
 for(z=1;z<9;z++) midisplay[z]=32;
 
 for(z=8;z>=0;z--)
    {
     if(scroll-z<0)
         c=32;
     else 
         c=VARI_scroll[scroll-z];
         
     midisplay[z]=c;
    }

  scroll++; 
  if(VARI_scroll[scroll]==0) scroll=0;
  DisplayP();  
 
}


//____MAX7219___________________

void spiTransfer(  byte opcode, byte data)
{
  digitalWrite(LEDCONTROL_SPI_CS,LOW);
  shiftOut(LEDCONTROL_SPI_MOSI,LEDCONTROL_SPI_CLK,MSBFIRST,opcode);
  shiftOut(LEDCONTROL_SPI_MOSI,LEDCONTROL_SPI_CLK,MSBFIRST,data);
  digitalWrite(LEDCONTROL_SPI_CS,HIGH);    
}

//Intensidad de los digitos
void setIntensity( byte intensity) 
{
    if(intensity>=0 || intensity<16) spiTransfer(10,intensity);    
}

//Inicializa el MAX7219
void LedControl(int dataPin, int clkPin, int csPin)
{
    LEDCONTROL_SPI_MOSI=dataPin;
    LEDCONTROL_SPI_CLK=clkPin;
    LEDCONTROL_SPI_CS=csPin;
    pinMode(LEDCONTROL_SPI_MOSI,OUTPUT);
    pinMode(LEDCONTROL_SPI_CLK,OUTPUT);
    pinMode(LEDCONTROL_SPI_CS,OUTPUT);
    digitalWrite(LEDCONTROL_SPI_CS,HIGH);
        
    spiTransfer(12,0);  //shudown
    spiTransfer(12,1);  //shudown
   
    spiTransfer( 11,0xFF); //scanlimit los 8 display
    spiTransfer(9,0);  //decodemode  modo segmentos
    spiTransfer(0x0F,1); delay(200); spiTransfer(0x0F,0);delay(200);spiTransfer(0x0F,1);delay(200);
    spiTransfer(0x0F,0);  //test mode
     
}

//Borra los 8 digitos
void DisplayClear()
{
 unsigned char z;
  for (z=1;z<9;z++)spiTransfer(z,0); 
}

//Imprimir cadena  
void DisplayS(char *cade)
{
 unsigned char z;
  for(z=1;z<9;z++) midisplay[z]=32; 
  for (z=1;z<9;z++)
    {
      if(cade[z-1]<15 ) break;    
      midisplay[9-z]=cade[z-1];
    }
  DisplayP();
}  

//Imprimir numero
void DisplayN(long int numero)
{
  unsigned char z;
  sprintf(VARI_scroll,"%08li",numero);  //ocupa 1500 bytes
  for (z=1;z<9;z++) midisplay[9-z]=VARI_scroll[z-1];
  DisplayP();
}  

//Pasa los digitos al MAX7219
void DisplayP()
{
 unsigned  char z;
 
  for (z=1;z<9;z++)
  {
    if(midisplay[z]>='a'&& midisplay[z]<='z') midisplay[z]=midisplay[z]-32; //Minusculas a mayusculas
    spiTransfer(z,segmentos[midisplay[z]-32]);  
  }
}



